#!/usr/bin/env python

class phpcode:
	def __init__(self, filename):
		fp = open(filename,"r")
		self.source = fp.read()
		self._strip()
		fp.close()

	def quote(self, data):
		data = data.replace("\\","\\\\")
		data = data.replace('"','\\"')
		#data = data.replace("'","\\'")
		return data

	def _strip(self):
		self.source = self.source.replace("\n","");

	def code(self, *args):
		template = self.source
		num = 1
		for arg in args:
			template = template.replace(template_arg_marker+str(num), self.quote(str(arg)))
			num += 1
		return template

template_arg_marker = "ARG_"

execCode = {
	#"proc_open"
	"popen" :
		{"code":phpcode("lib/code/popen.php"),"functions":["fread","popen"]},
	#"shell_exec"
	#"passthru"
	"system":
		{"code":phpcode("lib/code/system.php"),"functions":["system"]},
	#"exec"
			}

downloadCode = {
	"readfile":
		{"code":phpcode("lib/code/readfile.php"),"functions":["filesize","header","readfile"]},
			   }

# Arguments: 
uploadCode = {
	"move_uploaded_file":
		{"code":phpcode("lib/code/move_uploaded_file.php"),"functions":["move_uploaded_file"]},
			 }

databaseCode = {
	"mysql":
		{"code":phpcode("lib/code/mysql.php"),"functions":["mysql_connect",
														   "mysql_select_db",
														   "mysql_query",
														   "mysql_fetch_row",
														   "preg_match",
														   "mysql_info",
														   "mysql_affected_rows",
														   "implode",
														  ]
		},
	"sqlite":
		{"code":phpcode("lib/code/sqlite.php"),"functions":["sqlite_open",
															"sqlite_query",
															"sqlite_fetch_array",
															"sqlite_close",
														  ]
		},
	"pgsql":
		{"code":phpcode("lib/code/pgsql.php"),"functions":["pg_connect",
														   "pg_query",
														   "pg_last_error",
														   "pg_fetch_array",
														   "pg_free_result",
														   "pg_close",
														  ]
		}
			}

# Arguments: function to test, positive answer, negative answer
testCode = {
	"capability_test":
		{"code":phpcode("lib/code/capabilities.php"),"functions":[]},
		   }

